//<script type="text/javascript"> this does nothing, really. just to cheat dreamweaver.

<?php
	$url = NULL;
	if (isset ($_GET ['url'])){
		$url = $_GET ['url'];
	}else {
		die ();
	}			
?>

var GDocs = {
	
	/*
	 * Click handler
	 */
	ring: function (id, type, title){	// id: main_id+sub_id, type: document or spreadsheet
	
		/*
		 * The user has rung, now add the appropriate tag to the post/page content
		 */
		 
		// prepare string
		var str = "[gdocs type='";
					
		// separate id into main_id, sub_id
		var seps = id.split ("+");
					
		switch (type){
			
			case 'document': // Google Document
			
				str += "document' id='" + seps[0] + "']";
				break;
			
			case 'spreadsheet': // Google Spreadsheet
			
				str += "spreadsheet' st_id='" + seps[0] + "' wt_id='" + seps[1] + "']";
				break;
			
			default:
				
				return;
		}
		
		str += "\r\n";
		
		// add to textarea
		if ($('content').visible()){
			// if IE
			if (document.selection){
				$('content').focus();
				var sel = document.selection.createRange();
				sel.text = str;
				$('content').focus();
			}else { // anything else
				var pos = this.getCaretPos ($('content'));
				if (pos != false){ // Firefox, Opera
					var left = $('content').value.substring (0, pos);
					var right = $('content').value.substring (pos);
					$('content').value = left + str + right;
				}else {
					// non ff, non IE, non opera
					$('content').value += str;
				}
			}
		}else {
			// the really easy way out
			tinyMCE.activeEditor.execCommand ('mceInsertContent', false, str);
		}
		
		return false;
	
	},
	
	/*
	 * Find caret position
	 * For firefox and opera
	 */
	getCaretPos: function (ctrl) {

		try {
			
			if (ctrl.selectionStart || ctrl.selectionStart == '0') {
				return ctrl.selectionStart;
			}
			
			return false;
			
		}catch (e){
			return false;
		}
	
	},
	
	/*
	 * Update list of documents and spreadsheets
	 * AJAX request
	 */
	updateList: function (){
		
		// call php script to retrieve list of documents and spreadsheets
		new Ajax.Request ('<?php echo $url ?>/wp-content/plugins/gdocs/ajax-functions.php', {
			method: 'get',
			parameters: {action: 'update_list'},
			onSuccess: function (transport, json){
				GDocs._updateListHTML (transport, json);
			},
			onException: function (transport){
				GDocs._updateListException (transport);		
			},
			onFailure: function (transport){
				GDocs._updateListException (transport);
			}
		});
		
		// TODO global responders
		
	},
	
	/*
	 * AJAX Post-request handler
	 * Update HTML to display new list
	 */
	_updateListHTML: function (transport, json){
		
		// get div
		var div = $$ ('div#gdocs_helper div.inside');
		div = div[0];
		
		// clear
		div.update ('');
		
		// add update link
		var p = new Element ('p');
		var a = new Element ('a', {href: '#'}).update ('Update list');
		a.onclick = function() {return false;};

		p.appendChild (document.createTextNode ('('));
		p.appendChild (a);
		p.appendChild (document.createTextNode (')'));
		div.appendChild (p);
		
		Event.observe (a, 'click', function (){ GDocs.updateList(); return false; });
		
		// add tags
		json.each (function(ele){
		
			a = new Element ('a', {href: '#', id: ele.main_id + "+" + ele.sub_id}).update (ele.title);
			
			var cmd = "GDocs.ring ('" + ele.main_id + "+" + ele.sub_id + "', '" + ele.type + "', '" + ele.title + "');";
			a.onclick = function() {eval(cmd); return false;};
			
			var span = new Element ('span');
			
			span.appendChild (a);
			div.appendChild (span);
		
		});
	
	},
	
	/*
	 * AJAX Exception Handler
	 */
	_updateListException: function (transport){

		// get div
		var div = $$ ('div#gdocs_helper div.inside');
		div = div[0];
		
		var p = new Element ('p').update ('An error has occurred while trying to update the list of documents.');
		p.setStyle ('color', 'red');
		
		div.appendChild (p);
	
	}

	
}

// add ajax loading gif
Ajax.Responders.register ({
	onCreate: function (){
		// appear
		$('gdocs_helper_ajax').show ();
	},
	onComplete: function (){
		// hide
		$('gdocs_helper_ajax').hide ();
	}
});